aboutsummaryrefslogtreecommitdiff
path: root/sys
diff options
context:
space:
mode:
authorrafael2k <rafael2k@370017ae-e619-0410-ac65-c121f96126d4>2007-11-17 23:27:34 +0000
committerrafael2k <rafael2k@370017ae-e619-0410-ac65-c121f96126d4>2007-11-17 23:27:34 +0000
commit8d23fa490138d85c6184ca0da855ba98ba880c4e (patch)
treea16da7a7f84cf7d7bf1c7039385a4f4d5abca8b5 /sys
parentadc89ae75ffc0c9b0326a47230fb82a054b48232 (diff)
downloadslackbuilds-8d23fa490138d85c6184ca0da855ba98ba880c4e.tar.gz
slackbuilds-8d23fa490138d85c6184ca0da855ba98ba880c4e.tar.bz2
set_rlimits added
git-svn-id: svn+slack://slack.fluxo.info/var/svn/slackbuilds@1447 370017ae-e619-0410-ac65-c121f96126d4
Diffstat (limited to 'sys')
-rwxr-xr-xsys/process/set_rlimits/set_rlimits.SlackBuild165
1 files changed, 165 insertions, 0 deletions
diff --git a/sys/process/set_rlimits/set_rlimits.SlackBuild b/sys/process/set_rlimits/set_rlimits.SlackBuild
new file mode 100755
index 00000000..1594a155
--- /dev/null
+++ b/sys/process/set_rlimits/set_rlimits.SlackBuild
@@ -0,0 +1,165 @@
+#!/bin/bash
+#
+# set_rlimits.SlackBuild is free software; you can redistribute
+# it and/or modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of the License,
+# or any later version.
+#
+# htop.SlackBuild is distributed in the hope that it will
+# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+# Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place - Suite 330, Boston, MA 02111-1307, USA
+#
+# slackbuild for set_rlimits, by Rafael Diniz
+# tested: set_rlimits 1.2.0
+#
+
+# Look for slackbuildrc
+if [ -f ~/.slackbuildrc ]; then
+ source ~/.slackbuildrc
+elif [ -f /etc/slackbuildrc ]; then
+ source /etc/slackbuildrc
+fi
+
+# Set variables
+CWD="$(pwd)"
+SRC_NAME="set_rlimits"
+PKG_NAME="set_rlimits"
+ARCH=${ARCH:=i486}
+SRC_VERSION=${VERSION:=1.2.0}
+PKG_VERSION="$(echo "$SRC_VERSION" | tr '[[:blank:]-]' '_')"
+BUILD=${BUILD:=1rd}
+SRC_DIR=${SRC_DIR:=$CWD}/$PKG_NAME
+TMP=${TMP:=/tmp}
+PKG=${PKG:=$TMP/package-$PKG_NAME}
+REPOS=${REPOS:=$TMP}
+PREFIX=${PREFIX:=/usr}
+PKG_SRC="$TMP/$SRC_NAME-$SRC_VERSION"
+CONF_OPTIONS=${CONF_OPTIONS:=""}
+NUMJOBS=${NUMJOBS:="-j3"}
+
+# Set system libraries' path and optmization flags based on $ARCH
+LIBDIR="$PREFIX/lib"
+
+if [ "$ARCH" = "i386" ]; then
+ SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
+elif [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mcpu=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686"
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIR="$PREFIX/lib64"
+fi
+
+# Set error codes (used by createpkg)
+ERROR_WGET=31; ERROR_MAKE=32; ERROR_INSTALL=33
+ERROR_MD5=34; ERROR_CONF=35; ERROR_HELP=36
+ERROR_TAR=37; ERROR_MKPKG=38; ERROR_GPG=39
+ERROR_PATCH=40; ERROR_VCS=41; ERROR_MKDIR=42
+
+# Clean up any leftovers of previous builds
+rm -rf "$PKG_SRC" 2> /dev/null
+rm -rf "$PKG" 2> /dev/null
+
+# Create directories if necessary
+mkdir -p "$SRC_DIR" || exit $ERROR_MKDIR
+mkdir -p "$PKG" || exit $ERROR_MKDIR
+mkdir -p "$REPOS" || exit $ERROR_MKDIR
+
+# Dowload source if necessary
+SRC="$SRC_NAME-$VERSION.tgz"
+URL="http://www.physics.adelaide.edu.au/~jwoithe/$SRC"
+
+if [ ! -s "$SRC_DIR/$SRC" ] || ! gunzip -t "$SRC_DIR/$SRC" 2> /dev/null; then
+ wget "$URL" -O "$SRC_DIR/$SRC" || exit $ERROR_WGET
+fi
+
+
+# Untar
+cd "$TMP"
+tar --no-same-owner --no-same-permissions -xvf "$SRC_DIR/$SRC" || exit $ERROR_TAR
+cd "$PKG_SRC"
+
+# Compile
+make clean
+make $NUMJOBS || exit $ERROR_MAKE
+
+# Install
+mkdir -p "$PKG/usr/bin"
+mkdir -p "$PKG/etc"
+mkdir -p "$PKG/usr/man/man8/"
+cp set_rlimits.conf "$PKG/etc/set_rlimits.conf.orig"
+cp set_rlimits "$PKG/usr/bin"
+cp set_rlimits.8 "$PKG/usr/man/man8/"
+
+cat << EOC > "$PKG/etc/set_rlimits.conf"
+# configfile sample by rafael diniz
+# take a look at /etc/set_rlimits.conf.orig
+ @audio /usr/bin/jackd nice=-1 rtprio=85 memlock=256000
+ @audio /usr/bin/mplayer nice=-1 rtprio=79 memlock=256000
+ @audio /usr/bin/xmms nice=-1 rtprio=78 memlock=256000
+ @audio /usr/bin/qjackctl nice=-1 rtprio=60 memlock=256000
+EOC
+
+# set permissions
+chown root.root "$PKG/usr/bin/set_rlimits"
+chown root.root "$PKG/etc/set_rlimits.conf.orig"
+chown root.root "$PKG/etc/set_rlimits.conf"
+chown root.root "$PKG/usr/man/man8/set_rlimits.8"
+
+# set suid bit
+chmod u+s "$PKG/usr/bin/set_rlimits"
+
+
+# Strip binaries
+( cd "$PKG"
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | \
+ xargs strip --strip-unneeded 2> /dev/null
+)
+
+# Install documentation
+DOCS="AUTHORS COPYING README Changelog"
+mkdir -p "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION" || exit $ERROR_MKDIR
+cp -a $DOCS "$PKG/usr/doc/$PKG_NAME-$PKG_VERSION"
+
+# Add package description (slack-desc)
+mkdir -p "$PKG/install" || exit $ERROR_MKDIR
+cat << EODESC > "$PKG/install/slack-desc"
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler---------------------------------------------------------|
+set_rlimits: set_rlimits (give users access to realtime scheduling)
+set_rlimits:
+set_rlimits: It is a small program written to give unpriviledged users access to
+set_rlimits: realtime scheduling via the new rlimits added to kernel 2.6.12. The new
+set_rlimits: name reflects the fact that the program can control resource limits
+set_rlimits: rather than just those related to realtime priorities. This new version
+set_rlimits: adds a more flexible configuration file format, easier command line use
+set_rlimits: and the ability to control the memlock resource limit. Read the enclosed
+set_rlimits: README file and manpage for full details.
+set_rlimits:
+set_rlimits: http://www.physics.adelaide.edu.au/~jwoithe/
+EODESC
+
+# Build the package
+cd "$PKG"
+makepkg -l y -c n "$REPOS/$PKG_NAME-$PKG_VERSION-$ARCH-$BUILD.tgz" || exit $ERROR_MKPKG
+
+# Delete source and build directories if requested
+if [ "$CLEANUP" == "yes" ]; then
+ rm -rf "$PKG_SRC" "$PKG"
+fi